#include <EEPROM.h>
#include <LiquidCrystal.h>
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);
int  flag; 
void controllo(int);
void setup() 
{
  lcd.begin(16, 2);
  DDRA = 0B11111111;
  DDRC = 0B11111111;
  pinMode(12, INPUT_PULLUP);
  flag = EEPROM.read(0);
  lcd.setCursor(0, 0);
  lcd.print("TX 27 by Fabio");
  delay(2000);
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("CANALE ");
  lcd.print(flag);
  controllo(flag);
}
void loop() 
{
if(digitalRead(12) == 0)
  {
    if(flag == 40)
    {
        flag = 1; 
        lcd.clear();
    }
    else
        ++flag;
    lcd.setCursor(0, 0);
    lcd.print("CANALE ");
    lcd.print(flag);
    EEPROM.write(0, flag);     
    while(digitalRead(12) == 0);
    delay(300); 
    controllo(flag); 
  }                   
}
void controllo(int x)
{
  switch (x) 
  { 
  case 1: PORTA = 0B01100101;
          PORTC = 0B01101001;
          lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("26.965"); 
          lcd.print(" MHz");      
          break;
  case 2: PORTA = 0B01110101;
          PORTC = 0B01101001;
          lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("26.975"); 
          lcd.print(" MHz");    
          break; 
  case 3: PORTA = 0B10000101;
          PORTC = 0B01101001;
          lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("26.985"); 
          lcd.print(" MHz");    
          break;
  case 4: PORTA = 0B00000101;
          PORTC = 0B01110000;
          lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.005"); 
          lcd.print(" MHz");    
          break;   
  case 5: PORTA = 0B00010101;
          PORTC = 0B01110000;
          lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.015"); 
          lcd.print(" MHz");    
          break;
  case 6: PORTA = 0B00100101;
          PORTC = 0B01110000;
          lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.025"); 
          lcd.print(" MHz");    
          break; 
  case 7: PORTA = 0B00110101;
          PORTC = 0B01110000;
          lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.035"); 
          lcd.print(" MHz");    
          break;
  case 8: PORTA = 0B01010101;
          PORTC = 0B01110000;
          lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.055"); 
          lcd.print(" MHz");    
          break;    
  case 9: PORTA = 0B00110101;
          PORTC = 0B01110000;
          lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.065"); 
          lcd.print(" MHz");    
          break;
  case 10: PORTA = 0B01110101;
          PORTC = 0B01110000;
          lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.075"); 
          lcd.print(" MHz");    
          break; 
  case 11: PORTA = 0B10000101;
           PORTC = 0B01110000;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.085"); 
          lcd.print(" MHz");    
           break;
  case 12: PORTA = 0B00000101;
           PORTC = 0B01110001;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.105"); 
          lcd.print(" MHz");    
           break;   
  case 13: PORTA = 0B00010101;
           PORTC = 0B01110001;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.115"); 
          lcd.print(" MHz");    
           break;
  case 14: PORTA = 0B00100101;
           PORTC = 0B01110001;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.125"); 
          lcd.print(" MHz");    
           break; 
  case 15: PORTA = 0B00110101;
           PORTC = 0B01110001;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.135"); 
          lcd.print(" MHz");    
           break;
  case 16: PORTA = 0B01010101;
           PORTC = 0B01110001;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.155"); 
          lcd.print(" MHz");    
           break;    
  case 17: PORTA = 0B01100101;
           PORTC = 0B01110001;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.165"); 
          lcd.print(" MHz");    
           break;
  case 18: PORTA = 0B01110101;
           PORTC = 0B01110001;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.175"); 
          lcd.print(" MHz");    
           break; 
  case 19: PORTA = 0B01110101;
           PORTC = 0B01110001;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.185"); 
          lcd.print(" MHz");    
           break;
  case 20: PORTA = 0B00000101;
           PORTC = 0B01110010;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.205"); 
          lcd.print(" MHz");    
           break;   
  case 21: PORTA = 0B00010101;
           PORTC = 0B01110010;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.215"); 
          lcd.print(" MHz");    
           break;
  case 22: PORTA = 0B00100101;
           PORTC = 0B01110010;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.225"); 
          lcd.print(" MHz");    
           break; 
  case 23: PORTA = 0B01010101;
           PORTC = 0B01110010;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.255"); 
          lcd.print(" MHz");    
           break;
  case 24: PORTA = 0B00110101;
           PORTC = 0B01110010;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.235"); 
          lcd.print(" MHz");    
           break;    
  case 25: PORTA = 0B01000101;
           PORTC = 0B01110010;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.245"); 
          lcd.print(" MHz");    
           break;
  case 26: PORTA = 0B01100101;
           PORTC = 0B01110010;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.265"); 
          lcd.print(" MHz");    
           break; 
  case 27: PORTA = 0B01110101;
           PORTC = 0B01110010;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.275"); 
          lcd.print(" MHz");    
           break;
  case 28: PORTA = 0B10000101;
           PORTC = 0B01110010;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.285"); 
          lcd.print(" MHz");    
           break;   
  case 29: PORTA = 0B10010101;
           PORTC = 0B01110010;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.295"); 
          lcd.print(" MHz");    
           break;
  case 30: PORTA = 0B00000101;
           PORTC = 0B01110011;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.305"); 
          lcd.print(" MHz");    
           break; 
  case 31: PORTA = 0B00010101;
           PORTC = 0B01110011;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.315"); 
          lcd.print(" MHz");    
           break;
  case 32: PORTA = 0B00100101;
           PORTC = 0B01110011;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.325"); 
          lcd.print(" MHz");    
           break; 
  case 33: PORTA = 0B00110101;
           PORTC = 0B01110011;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.335"); 
          lcd.print(" MHz");    
           break;    
  case 34: PORTA = 0B01000101;
           PORTC = 0B01110011;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.345"); 
          lcd.print(" MHz");    
           break;
  case 35: PORTA = 0B01010101;
           PORTC = 0B01110011;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.355"); 
          lcd.print(" MHz");    
           break; 
  case 36: PORTA = 0B01100101;
           PORTC = 0B01110011;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.365"); 
          lcd.print(" MHz");    
           break;
  case 37: PORTA = 0B01110101;
           PORTC = 0B01110011;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.375"); 
          lcd.print(" MHz");    
           break;   
  case 38: PORTA = 0B10000101;
           PORTC = 0B01110011;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.385"); 
          lcd.print(" MHz");    
           break;
  case 39: PORTA = 0B10010101;
           PORTC = 0B01110011;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.395"); 
          lcd.print(" MHz");    
          break; 
  case 40: PORTA = 0B00000101;
           PORTC = 0B01110100;
           lcd.setCursor(0, 0);
          lcd.print("CANALE ");
          lcd.print(x);    
          lcd.setCursor(0, 1);  
          lcd.print("27.405"); 
          lcd.print(" MHz");    
           break; 
  defoult: break;
  }  
}   
